;*****************************************************************************
;*   8- CRC.                                        *
;*****************************************************************************
;  :
;       clrf    fCRC     ;     fCRC.
        movf    fBYTE1,w ;    .
        call    DO_CRC
;  fCRC      fBYTE1.
        movf    fBYTE2,w
        call    DO_CRC
;  fCRC      fBYTE1  fBYTE2.
        movf    fBYTE3,w
        call    DO_CRC
;  fCRC      fBYTE1, fBYTE2, fBYTE3.
;   .
; 8- CRC       200 .
        
fCRC:       res  1   ;  .
SAVE_W:     res  1
fBIT_CNT:   res  1   ;  .
fTEMP:      res  1   ;      .

;   CRC (  ).   W.
DO_CRC: ;  CRC - 8 .
        movwf   SAVE_W
        movlw   0x08
        movwf   fBIT_CNT
        movf    SAVE_W,0
DoCRC_Loop:
        xorwf   fCRC,0
        movwf   fTEMP
        rrf     fTEMP,0
        movf    fCRC,0
        btfsc   STATUS,0
        xorlw   0x18
        movwf   fTEMP
        rrf     fTEMP,0
        movwf   fCRC
        bcf     STATUS,0
        rrf     SAVE_W,1
        movf    SAVE_W,0
        decfsz  fBIT_CNT,1
        goto    DoCRC_Loop
        return
;----------------------------------------------------------------------------- 
