; 1820  PA   
;      0  3
  Cblock 0x80
DSMAG
DSSIGN
TMP0
TMP1
TMP2
PA
  endc
  

Data_temp macro dt
      CLRF  PA
  if dt == 1
  Bsf  PA,0
  endif
  if dt == 2
  Bsf  PA,1
  endif
  if dt == 3
  Bsf  PA,2
  endif
  if dt == 4
  Bsf  PA,3
  endif   
      Call NEWTEMP
  endm
  
NEWTEMP:  
      CALL    DSRX8    ;  
      ADDLW   1
      BTFSS   STATUS,Z
      BRA    NEWTEMP    ;    
GETTEMP:
      CALL    DSRESET    ;   
      BTFSS   STATUS,Z
      RETURN        ; 
      MOVLW   0XCC
      CALL    DSTX8    ;   
      MOVLW   0XBE
      CALL    DSTX8    ;  
      CALL    DSRX8    ; 
      MOVWF   DSMAG
      CALL    DSRX8    ;  
      MOVWF   DSSIGN
      CALL    DSRESET    ;   
      MOVLW   0XCC
      CALL    DSTX8    ;   
      MOVLW   0X44
      CALL    DSTX8    ;   
      MOVF    DSSIGN,W  ;   ,
      BTFSC   STATUS,Z  ;   255  0.
      BRA    OKTMP
      ADDLW   1
      BTFSS   STATUS,Z
      RETURN
OKTMP:    
      CLRF  W
      RETURN
;        
DQLOW:    
      BTFSC  PA,0
      BRA  DTC0
      BTFSC  PA,1
      BRA  DTC1
      BTFSC  PA,2
      BRA  DTC2
      BTFSC  PA,3
      BRA  DTC3
      RETURN
DTC0:    
      BCF     PORTA,0    ;  ,   
      BCF     TRISA,0
      RETURN
DTC1:    
      BCF     PORTA,1    ;  ,   
      BCF     TRISA,1
      RETURN
DTC2:
      BCF     PORTA,2    ;  ,    
      BCF     TRISA,2
      RETURN
DTC3: 
      BCF     PORTA,3    ;  ,   
      BCF     TRISA,3
      RETURN
      
DQHIZ:
      BTFSC    PA,0
      BRA  DTS0
      BTFSC  PA,1
      BRA  DTS1
      BTFSC  PA,2
      BRA  DTS2
      BTFSC  PA,3
      BRA  DTS3
      RETURN
DTS3:   
      BSF     TRISA,3    
      RETURN
DTS0:  
      BSF     TRISA,0
      RETURN
DTS1:  
      BSF     TRISA,1
      RETURN
DTS2:   
      BSF     TRISA,2
      RETURN

; ,    

PAUSE   macro  DLYF
      MOVLW  DLYF
      MOVWF   TMP0
      CALL  DLY5N
    endm
DLY5N
      NOP
      NOP
      DECFSZ  TMP0,F
      BRA    DLY5N
      RETURN    
  
;       
DSRESET:  CALL  DQLOW
      PAUSE  0x77
      CALL  DQHIZ
      PAUSE  0x0c    ;     67 
      NOP
      NOP
      MOVF    PORTA,W
      BTFSC  PA,1
      BRA  DTR1
      BTFSC  PA,0
      BRA  DTR0
      BTFSC  PA,2
      BRA  DTR2
DTR3:    
      ANDLW   1<<3
      BRA  METDR
DTR0:    
      ANDLW   1<<0
      BRA  METDR
DTR1:    
      ANDLW   1<<1
      BRA  METDR
DTR2:    
      ANDLW   1<<2
METDR:    
      MOVWF   TMP1
      PAUSE   0x3b
      MOVF    TMP1,W
      RETURN
;     
DSTX8:    
      MOVWF   TMP2
      MOVLW   8
      MOVWF   TMP1  ; 
DSTXLP:
      CALL  DQLOW
      PAUSE  0x01
      RRCF     TMP2,F
      BTFSC   STATUS,C  
      BRA  DTB
      BRA  METX
DTB:
      BTFSC  PA,1
      BRA  DTX1
      BTFSC  PA,0
      BRA  DTX0
      BTFSC  PA,2
      BRA  DTX2
DTX3:    
      BSF     PORTA,3
      BRA  METX
DTX0:    
      BSF     PORTA,0
      BRA  METX
DTX1:    
      BSF     PORTA,1
      BRA  METX
DTX2:    
      BSF     PORTA,2
METX:    
      PAUSE  0x0d
      CALL  DQHIZ
      NOP
      DECFSZ  TMP1,F
      BRA    DSTXLP
      RETURN
;     
DSRX8:    
      MOVLW   8
      MOVWF   TMP1
DSRXLP:    
      CALL  DQLOW
      PAUSE  0x01
      CALL  DQHIZ
      NOP
      NOP
      MOVF    PORTA,W
      BTFSC  PA,2
      BRA  DTRX2
      BTFSC  PA,0
      BRA  DTRX0
      BTFSC  PA,1
      BRA  DTRX1
DTRX3:    
      ANDLW   1<<3
      BRA  METRX
DTRX0:    
      ANDLW   1<<0
      BRA  METRX
DTRX1:    
      ANDLW   1<<1
      BRA  METRX
DTRX2:    
      ANDLW   1<<2
METRX:    
      ADDLW   .255
      RRCF     TMP2,F
      PAUSE  0x0b
      DECFSZ  TMP1,F
      BRA    DSRXLP
      MOVF    TMP2,W
      RETURN
