;*********************************************************
      ;    
get_packet:
	;Displ_Text 2,0,"GET"
	write_creg	CR, H'1A'
	MOVLW		H'04'
	MOVWF		I
	LFSR		FSR0,pageheader
get_met:
	read_creg 	RDMAPORT
	MOVFF		BUFF,POSTINC0	
	DECFSZ		I,F
	BRA		get_met	
;     
	MOVFF		enetpacketLenL,TEMPL
	MOVFF		enetpacketLenH,TEMPH	
	LFSR		FSR0,packet		; 
	CLRF		I				; 
gmet0:
	read_creg	RDMAPORT
	MOVLW		d'96'
	CPFSLT		I			; I<96
	BRA		gmet1
	MOVFF		BUFF,POSTINC0 ;       BUFF
	INCF 		I, F
	;      enetpacketLenL  enetpacketLenH
gmet1:	
	DECFSZ		TEMPL,F
	BRA		gmet0
	TSTFSZ		TEMPH
	BRA		gmet2
	BRA		gmet3	
gmet2:
	DECF		TEMPL,F
	DECF		TEMPH,F
	BRA		gmet0
gmet3:	
	read_creg	ISR
	BTFSS		BUFF,RDC
	BRA		gmet3
	write_creg	ISR, H'FF'
	
;  ARP - 
;if enetpacketType0 == 0x08 
	MOVFF		enetpacketType0,TEMP0
	MOVLW		H'08'
	CPFSEQ		TEMP0
	RETURN	
;if enetpacketType1 == 0x06
	MOVFF		enetpacketType1,TEMP0
	MOVLW		H'06'
	CPFSEQ		TEMP0
	goto		gmet5	;else
;if arp_hwtype+1 = 0x01
	MOVFF		arp_hwtype + 1,TEMP0
	MOVLW		H'01'
	CPFSEQ		TEMP0
	RETURN
;if arp_prtype = 0x08
	MOVFF		arp_prtype,TEMP0
	MOVLW		H'08'
	CPFSEQ		TEMP0
	RETURN
;if arp_prtype+1 = 0x00
	MOVFF		arp_prtype+1,TEMP0
	TSTFSZ		TEMP0
	RETURN
;if arp_hwlen = 0x06
	MOVFF		arp_hwlen,TEMP0
	MOVLW		H'06'
	CPFSEQ		TEMP0
	RETURN
;if arp_prlen = 0x04
	MOVFF		arp_prlen,TEMP0
	MOVLW		H'04'
	CPFSEQ		TEMP0
	RETURN
;if arp_op+1 = 0x01
	MOVFF		arp_op+1,TEMP0
	MOVLW		H'01'
	CPFSEQ		TEMP0
	RETURN
;if MYIP = arp_thaddr
	MOVFF		arp_tipaddr,TEMP0
	MOVF		MYIP  ,W
	CPFSEQ		TEMP0
	RETURN
	MOVFF		arp_tipaddr+1,TEMP0
	MOVF		MYIP+1,W
	CPFSEQ		TEMP0
	RETURN
	MOVFF		arp_tipaddr+2,TEMP0
	MOVF		MYIP +2,W
	CPFSEQ		TEMP0
	RETURN
	MOVFF		arp_tipaddr+3,TEMP0
	MOVF		MYIP+3,W
	CPFSEQ		TEMP0
	RETURN
	;Displ_Text 2,5,"arp"
	CALL	arp
	RETURN
gmet5:	;  IP - 
		;if enetpacketType1 == 0x00
	MOVFF		enetpacketType1,TEMP0
	MOVLW		H'00'
	CPFSEQ		TEMP0
	RETURN	;else	
	MOVFF		ip_destaddr,TEMP0
	MOVF		MYIP ,W
	CPFSEQ		TEMP0
	RETURN
	MOVFF		ip_destaddr+1,TEMP0
	MOVF		MYIP + 1,W
	CPFSEQ		TEMP0
	RETURN
	MOVFF		ip_destaddr+2,TEMP0
	MOVF		MYIP + 2,W
	CPFSEQ		TEMP0
	RETURN
	MOVFF		ip_destaddr+3,TEMP0
	MOVF		MYIP + 3,W
	CPFSEQ		TEMP0
	RETURN
;if ip_proto = PROT_ICMP
	MOVFF		ip_proto,TEMP0
	MOVLW		PROT_ICMP
	CPFSEQ		TEMP0
	BRA		met_udp
	;Displ_Text 2,.10,"icmp"
   	CALL icmp
   	RETURN
;if ip_proto = PROT_UDP
met_udp:
	MOVFF		ip_proto,TEMP0
	MOVLW		PROT_UDP
	CPFSEQ		TEMP0
	BRA		met_tcp
   	CALL udp
   	RETURN
;if ip_proto = PROT_TCP
met_tcp:
	MOVFF		ip_proto,TEMP0
	MOVLW		PROT_TCP
	CPFSEQ		TEMP0
	RETURN
	CALL tcp
	RETURN

;****************************************************
arp:
	;	Displ_Text 3,0,"ARP"
	;	incf	x2,f
;ARP - 
;Perform ARP Response
;This routine supplies a requesting computer with the
;Ethernet modules's MAC (hardware) address.
;start the NIC
   		write_creg CR, H'22' 
;load beginning page for transmit buffer
   		write_creg TPSR,txstart  
;set start address for remote DMA operation
   		write_creg RSAR0, H'00'  
   		write_creg RSAR1, H'40'  
;clear the Interrupts
   		write_creg ISR, H'FF' 
;load data byte count for remote DMA
   		write_creg RBCR0, H'3C'  
   		write_creg RBCR1, H'00' 
;do remote write operation
   		write_creg CR, H'12'  
;write destination MAC address
i=0
	while i < 6		
		MOVFF enetpacketSrc0+i,TEMP0
		write_breg RDMAPORT,TEMP0
i=i+1
		endw		
;write source MAC address
i=0
	while i<6
		MOVFF MYMAC+i,TEMP0
		write_breg RDMAPORT,TEMP0
i=i+1
	endw
;write typelen hwtype prtype hwlen prlen op:
		write_creg RDMAPORT, H'08' 
		write_creg RDMAPORT, H'06' 
		write_creg RDMAPORT, H'00' 
		write_creg RDMAPORT, H'01' 
		write_creg RDMAPORT, H'08' 
		write_creg RDMAPORT, H'00' 
		write_creg RDMAPORT, H'06' 
		write_creg RDMAPORT, H'04' 
		write_creg RDMAPORT, H'00' 
		write_creg RDMAPORT, H'02' 
;write ethernet module MAC address
i=0
	while i<6
		MOVFF MYMAC+i,TEMP0
		write_breg RDMAPORT,TEMP0
i=i+1
	endw 
;write ethernet module IP address
i=0
	while i<4
		MOVFF MYIP+i,TEMP0
		write_breg RDMAPORT,TEMP0
i=i+1
	endw
;write remote MAC address
i=0
	while i < 6		
		MOVFF enetpacketSrc0+i,TEMP0
		write_breg RDMAPORT,TEMP0
i=i+1
		endw		
;write remote IP address
i=0
	while i < 4		
		MOVFF arp_sipaddr+i,TEMP0
		write_breg RDMAPORT,TEMP0
i=i+1
		endw		
;write some pad characters to fill out the packet to
;the minimum length
i=0
	while i < 12
		write_creg RDMAPORT, H'00'
i = i + 1
	endw		
;make sure the DMA operation has successfully completed
ARP_MET8:
      	read_creg ISR 
		BTFSS	BUFF,RDC
		BRA	ARP_MET8
		;Displ_Reg 3,5,x2
;load number of bytes to be transmitted
   		write_creg	TBCR0, H'3C'	;
   		write_creg	TBCR1, H'00'	;
;send the contents of the transmit buffer onto the network
   		write_creg	CR, H'24'
		RETURN
;***************************************************
icmp:	
		;Displ_Text 4,0,"icmp"
		;incf x3,f
;set echo reply
		LFSR	FSR0,ICMP_type
		CLRF	POSTINC0		;CLRF	ICMP_type
		CLRF	POSTINC0		;CLRF	ICMP_code
;clear the ICMP checksum
		CLRF	POSTINC0		;CLRF	ICMP_cksum
		CLRF	INDF0			;CLRF	ICMP_cksum+1	
;setup the IP header
   		CALL 	setipaddrs		;
;calculate the ICMP checksum
		MOVFF   ip_pktlen+1,TEMPL
		MOVFF	ip_pktlen,TEMPH
		MOVFF	ip_vers_len,TEMP0
		MOVF	TEMP0,W
		ANDLW	H'0F'			; 0x0f   		;		
		MULLW	H'04'			;  32 (4 )
		MOVF	PRODL,W			;  PRODL  PRODH
		SUBWF	TEMPL,F			;  -  ICMP .  
		BTFSC	STATUS,N		;      
		INCF	PRODH,F			;   1 	
		MOVF	PRODH,W
		SUBWF	TEMPH,F			; ICMP .  	
		MOVFF	TEMPL,TEMP0	
		MOVFF	TEMPH,TEMP1
		LFSR	FSR0,ICMP_type
   		CALL	cksum			;
		MOVFF	ARG1,ICMP_cksum
		MOVFF	ARG0,ICMP_cksum +1
;		MOVFF	TEMP0,TEMPL
;		MOVFF	TEMP1,TEMPH
;		LFSR	FSR0,ICMP_type
 ;  	CALL	cksum
;		MOVFF	ARG1,TEMP3
;		MOVFF	ARG0,TEMP4
;		Displ_Reg 4,.7,TEMP1
;		Displ_Reg 4,.9,TEMP0
;		Displ_Reg 4,.12,ARG1
;		Displ_Reg 4,.14,ARG0
;send the ICMP packet along on its way
	;	Displ_Reg 4,5,x3
   		CALL	echo_packet		;
		RETURN
;******************************************************************
;*	SETIPADDRS
;*   This function builds the IP header.
;******************************************************************
setipaddrs:
;move IP source address to destination address
i=0
	while i < 4
		MOVFF	ip_srcaddr+i,ip_destaddr+i
i=i+1
	endw	
;make ethernet module IP address source address
i=0
	while	i < 4
		MOVFF	MYIP+i,ip_srcaddr+i
i=i+1
	endw
;move hardware source address to destinatin address
i=0
	while i<6
		MOVFF	enetpacketSrc0+i,enetpacketDest0+i
i=i+1
	endw
;make ethernet module mac address the source address
i=0
	while i<6
		MOVFF	MYMAC+i,enetpacketSrc0+i
i=i+1
	endw
;calculate the IP header checksum
		LFSR	FSR0,ip_hdr_cksum
		CLRF	POSTINC0
		CLRF	INDF0
		CLRF	TEMPL
		CLRF	TEMPH
		MOVFF	ip_vers_len,TEMP0
		MOVF	TEMP0,W
		ANDLW	H'0F'
		MULLW	H'04'
		MOVFF	PRODL,TEMPL
		LFSR	FSR0,ip_vers_len
   		CALL	cksum		;
		MOVFF	ARG1,ip_hdr_cksum
		MOVFF	ARG0,ip_hdr_cksum +1
;     -  0x00 0x00       
;		OVLW	H'14'
;		MOVWF	TEMPL
;		CLRF	TEMPH
;		LFSR	FSR0,ip_vers_len
;   	CALL	cksum
;		MOVFF	ARG0,TEMP3
;		MOVFF	ARG1,TEMP4
 		RETURN
;******************************************************************
;*	Echo Packet Function
;*   This routine does not modify the incoming packet size and
;*   thus echoes the original packet structure.
;******************************************************************
echo_packet:
		;Displ_Text 5,0,"echo"
		;incf	x4,f
   		write_creg 	CR,H'22' 		;
   		write_creg 	TPSR,txstart 	;
   		write_creg 	RSAR0,H'00' 		;
   		write_creg 	RSAR1,H'40'		;
   		write_creg 	ISR,H'FF'		;
		MOVFF		enetpacketLenH,TEMPH				
		MOVFF		enetpacketLenL,TEMPL
		MOVLW		H'04'	;IPHEADERLEN
		SUBWF		TEMPL,F
		BTFSC		STATUS,N
		DECF		TEMPH,F
   		write_breg 	RBCR0,TEMPL
   		write_breg 	RBCR1,TEMPH
   		write_creg 	CR,H'12'	
   		MOVFF	TEMPL,TEMP0
   		MOVFF	TEMPH,TEMP1		;
   	;INCF	TEMPL,F
;     
		LFSR		FSR0,enetpacketDest0	; 
echo_met1:
		write_breg RDMAPORT,POSTINC0	;TEMP0		;
;      enetpacketLenL  enetpacketLenH
		DECFSZ		TEMPL
		BRA		echo_met1
		TSTFSZ		TEMPH
		BRA		echo_tst0H
		BRA		echo_met2
echo_tst0H:	
		DECF		TEMPL,F
		DECFSZ		TEMPH,F
		BRA		echo_met1
echo_met2:
		read_creg 	ISR		;
		BTFSS		BUFF,RDC
		BRA		echo_met2
		MOVFF		TEMP1,TEMPH				
		MOVFF		TEMP0,TEMPL
   		write_breg 	TBCR0,TEMPL
   		write_breg 	TBCR1,TEMPH
   		write_creg 	CR,H'24'
   	;	Displ_Reg	5,5,x4
		RETURN
udp:
	bsf	PORTA,1
	RETURN
tcp:
	BSF	PORTA,2
	RETURN
	
; 
overrun:
		;Displ_Text	1,0,"OVER"
		;incf		x1,f
   		read_creg 	CR 			;
		MOVFF		BUFF,TEMPL 
   		write_creg 	CR, H'21' 		;
   		Delay_ms 	2 			;
   		write_creg 	RBCR0, H'00' 		;
   		write_creg 	RBCR1, H'00' 		;
;if(!bit_test(data_L,2))
		BTFSC		TEMPL,2	
		BRA		ovmet0
;else if(bit_test(data_L,2)
        read_creg 	ISR			;
		MOVFF		BUFF,TEMPL
;if(bit_test(data_L,1) || bit_test(data_L,3))
		BTFSS		TEMPL,1
		BRA		ovmet1
		BTFSS		TEMPL,3
		BRA		ovmet1
		MOVLW		H'01'
		MOVWF		resend 			;
   		BRA 		ovmet1
ovmet0:
		CLRF 		resend 
ovmet1:
   		write_creg 	TCR,H'02' 		;
   		write_creg 	CR, H'22'		;
   		write_creg 	BNRY,rxstart		;
   		write_creg 	CR, H'62'		;
   		write_creg 	CURR,rxstart		;
   		write_creg 	CR, H'22'		;
   		write_creg 	ISR,H'10'		;
   		write_creg 	TCR,tcrval		;
   		;Displ_Reg	1,5, x1
		RETURN	