#include P18F4520.inc
_BODEN_OFF
_LVP_OFF
_HS_OSC_
_PWRT_ON_
_WDT_OFF_

	cblock h'00'
I	
TEMP 	
TEMP0	
TEMP1	
TEMP2	
TEMP3	
TEMP4	
ADDR		
BUFF
X
x1
x2
x3
x4
x5
	endc


;+++++++  +++++++++++
#define IORB            PORTE,0
#define IOWB            PORTE,1
#define RST_RTL         PORTE,2
;    -  1533  7
; 0-3     5-7,        1
;  -       1,     - !
#define  CS_ADR         PORTC,0
#define  CS_DEV         PORTC,1
#define  EN           PORTC,2

;       
;         0
;  D            ,0


		ORG  H'00'
		GOTO   BEGIN

		ORG  H'08'
		GOTO   Int1

		ORG  H'18'
		GOTO   Int2

#include GrafLCD.inc
#include Delay.inc
#include RTL8019.inc
#include Inet.inc
#include CKSum.inc
#include pausems.inc
#include IO.inc

Int1:
	;Displ_Text 0 ,.15 , "Int1"
      	RETURN

Int2:   
	;Displ_Text 1 ,.15 , "Int2"
      	RETURN

	
BEGIN:
		CLRF		PORTA
		CLRF		LATA
    	MOVLW    	H'07'
    	MOVWF    	ADCON1
    	MOVLW    	B'00000'
    	MOVWF    	TRISA
		CLRF		PORTB
		CLRF		LATB
    	MOVLW    	B'00001001'
    	MOVWF    	TRISB
		CLRF		PORTC
		CLRF		LATC
    	MOVLW    	B'00000000'
    	MOVWF    	TRISC
		CLRF		PORTD
		CLRF		LATD
    	CLRF    	TRISD
		CLRF		PORTE
		CLRF		LATE
    	CLRF    	TRISE
   		CLRF	 	INTCON
		CLRF	 	INTCON2
;  RTL8019    
		BSF		IORB
		BSF		IOWB
		BSF		RST_RTL
		BCF		CS_ADR
		BCF		CS_DEV
		BCF		EN
;   ++++++++++++		
		CLRF 	X		;  
		CLRF	Y		;  ARP
		CLRF	x1
		CLRF	x2
		CLRF	x3
		CLRF	x4
	
; RTL
		Init_RTL8019
; LCD	
		InitLCD
;   INT0 - RTL8019		
		BSF		INTCON,INT0IE
		
		Displ_Clr
		Displ_Text 	0 ,0 , "Test"	;test 
; !!!
		Device_on 1
		Device_on 3 
		Device_on 5 
		
main:
		write_creg	CR, h'22' 
		BTFSS		INTCON,INT0IF
		BRA		main
;            .
		BCF		INTCON,INT0IF
;		INCF	X,F				;  test
;		Displ_Reg 	0 ,0 , X	;test 
		read_creg	ISR
		BTFSC		BUFF,OVW
   		CALL		overrun	
   		BTFSC		BUFF,PRX
   		CALL		get_packet
;if BNRY = CURR, the buffer is empty
      	read_creg 	BNRY			
       	MOVFF 		BUFF,TEMPL
      	write_creg  	CR, H'62'
        read_creg 	CURR			
        MOVFF 		BUFF,TEMPH
      	write_creg 	CR, H'22'		
;buffer is not empty.. get next packet
    	MOVF		TEMPH,W
      	CPFSEQ		TEMPL
       	CALL 		get_packet		
;  
		write_creg	ISR ,H'FF'		
		;write_creg	CR, h'22'
     	Goto 		main
     	
#include shrift.inc  
	END	